import {NgModule} from '@angular/core';
import {Routes, RouterModule} from '@angular/router';

const routes: Routes = [
  {
    path: "",
    redirectTo: "/home/suit-company", pathMatch: "full",
  },
  {
    path: 'home',
    loadChildren: () => import('../modules/home/home.module').then(m => m.HomeModule)
  },
  {
    path: 'user',
    loadChildren: () => import('../modules/user/user.module').then(m => m.UserModule)
  },
  {
    path: 'meta',
    loadChildren: () => import('../modules/meta/meta.module').then(m => m.MetaModule)
  },
  {
    path: 'map',
    loadChildren: () => import('../modules/map/map.module').then(m => m.MapModule)
  },
  {
    path: 'chart',
    loadChildren: () => import('../modules/chart/chart.module').then(m => m.ChartModule)
  },
  {
    path: 'file',
    loadChildren: () => import('../modules/file/file.module').then(m => m.FileModule)
  },

];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule]
})
export class AppRoutingModule {
}
