import {NgModule} from '@angular/core';
import {CommonModule} from '@angular/common';

import {HomeRoutingModule} from './home-routing.module';
import {SuitCompaniesCompComponent} from "./suit-companies-comp/suit-companies-comp.component";
import {NzListModule} from "ng-zorro-antd/list";
import {NzPopoverModule} from "ng-zorro-antd/popover";
import {NzAvatarModule} from "ng-zorro-antd/avatar";
import {NavMenuComponent} from './nav-menu/nav-menu.component';
import {NzLayoutModule} from "ng-zorro-antd/layout";
import {NzMenuModule} from "ng-zorro-antd/menu";
import {NzIconModule} from "ng-zorro-antd/icon";
import {PageMineComponent} from './page-mine/page-mine.component';
import {IonicModule} from "@ionic/angular";
import {NzCarouselModule} from "ng-zorro-antd/carousel";
import {NzCardModule} from "ng-zorro-antd/card";
import {NzGridModule} from "ng-zorro-antd/grid";
import {RecommendedTemplatesComponent} from './recommended-templates/recommended-templates.component';
import {NzDescriptionsModule} from "ng-zorro-antd/descriptions";
import {TooltipModule} from 'ngx-bootstrap/tooltip';
import {TabsModule} from "ngx-bootstrap/tabs";
import {NzBadgeModule} from "ng-zorro-antd/badge";
import {TruncatePipe} from "./suit-companies-comp/truncate.pipe";
import {AllcompanyComponent} from './allcompany/allcompany.component';
import {NzInputModule} from "ng-zorro-antd/input";
import {NzSpinModule} from "ng-zorro-antd/spin";
import {CompanydetailComponent} from './companydetail/companydetail.component';
import {NzTabsModule} from "ng-zorro-antd/tabs";
import {NzModalModule} from "ng-zorro-antd/modal";
import {NzButtonModule} from 'ng-zorro-antd/button';
import {MockInterviewsComponent} from './mock-interviews/mock-interviews.component';
import {ReactiveFormsModule} from '@angular/forms';
import {NzStepsModule} from "ng-zorro-antd/steps";
import {FormsModule} from '@angular/forms';
import {ExperienceSquareComponent} from './experience-square/experience-square.component';
import {NzDividerModule} from "ng-zorro-antd/divider";
import {NzTypographyModule} from "ng-zorro-antd/typography";
import {NzCommentModule} from "ng-zorro-antd/comment";
import {TruncatePipeText} from "./truncate/truncate.pipe"
import {NzToolTipModule} from "ng-zorro-antd/tooltip";
import {ExperienceSquareUserComponent} from './experience-square-user/experience-square-user.component';
import {
  ExperienceSquareInformationComponent
} from './experience-square-information/experience-square-information.component';
import {MapModule} from "../map/map.module";
import {NzDrawerModule} from "ng-zorro-antd/drawer";

@NgModule({
  declarations: [
    SuitCompaniesCompComponent,
    NavMenuComponent,
    PageMineComponent,
    RecommendedTemplatesComponent,
    TruncatePipe,
    AllcompanyComponent,
    CompanydetailComponent,
    MockInterviewsComponent,
    ExperienceSquareComponent,
    TruncatePipeText,
    ExperienceSquareUserComponent,
    ExperienceSquareInformationComponent,
  ],
    imports: [
        CommonModule,
        HomeRoutingModule,
        NzListModule,
        NzPopoverModule,
        NzAvatarModule,
        NzLayoutModule,
        NzMenuModule,
        NzIconModule,
        IonicModule,
        NzCarouselModule,
        NzCardModule,
        NzGridModule,
        NzDescriptionsModule,
        TooltipModule,
        TabsModule,
        NzBadgeModule,
        NzInputModule,
        NzSpinModule,
        NzTabsModule,
        NzModalModule,
        NzButtonModule,
        ReactiveFormsModule,
        NzStepsModule,
        FormsModule,
        NzDividerModule,
        NzTypographyModule,
        NzCommentModule,
        NzToolTipModule,
        MapModule,
        NzDrawerModule,

    ]
})
export class HomeModule {
}
