import {NgModule} from '@angular/core';
import {CommonModule} from '@angular/common';
import {RouterModule, Routes} from '@angular/router';
// import { EditAmapPositionPickerModule } from './edit-amap-position-picker';
import {CompPoiPickerModule} from './comp-poi-picker/comp-poi-picker.module';
import {PageMapStartComponent} from "./page-map-start/page-map-start.component";
import {CompRunOrderComponent} from "./comp-run-order/comp-run-order.component";
import {PagePlanRouteComponent} from "./page-plan-route/page-plan-route.component";
import {PagePlanInfoComponent} from './page-plan-info/page-plan-info.component';
import {CompPlanRouteComponent} from './comp-plan-route/comp-plan-route.component';
import {NzTabsModule} from "ng-zorro-antd/tabs";
import {NzSegmentedModule} from "ng-zorro-antd/segmented";

const routes: Routes = [
  {
    path: "start", component: PageMapStartComponent
  },
  {
    path: "run/order", component: CompRunOrderComponent
  },
  {
    path: "plan", component: PagePlanRouteComponent
  },
  {
    path: "planroute", component: CompPlanRouteComponent
  }

];

@NgModule({
  declarations: [
    PageMapStartComponent,
    CompRunOrderComponent,
    PagePlanRouteComponent,
    PagePlanInfoComponent,
    CompPlanRouteComponent,
  ],
  exports: [
    PagePlanRouteComponent,
    CompPlanRouteComponent
  ],
  imports: [
    CommonModule,
    // EditAmapPositionPickerModule,
    RouterModule.forChild(routes),
    // 引用自定义独立组件模块
    CompPoiPickerModule,
    NzTabsModule,
    NzSegmentedModule
  ]
})
export class MapModule {
}
